#!/usr/bin/env perl
use strict;
use warnings;
use Perl6::Say;

my $v1 = { perl => 5, web => 2,  google => 1  };
my $v2 = { perl => 0, web => 5,  google => 10 };
my $v3 = { perl => 0, web => 10, google => 5  };

say cos_sim($v1, $v2);
say cos_sim($v1, $v3);
say cos_sim($v2, $v3);

sub cos_sim {
    my ($v1, $v2) = @_;
    return dot_product($v1, $v2)
        / (vec_abs($v1) * vec_abs($v2));
}

sub dot_product {
    my ($v1, $v2) = @_;
    my $v = 0;
    for (keys %$v1) {
        if ($v1->{$_} and $v2->{$_}) {
            $v += $v1->{$_} * $v2->{$_};
        }
    }
    return $v;
}

sub vec_abs {
    my $vec = shift;
    my $v = 0;
    for (values %$vec) {
        $v += $_ * $_;
    }
    return sqrt $v;
}
